apiVersion: "networking.k8s.io/v1"
kind: "Ingress"
metadata:
  name: {{ include "webui.fullname" . }}
  labels: {{- include "webui.labels" . | nindent 4 }}
  annotations:
    kubernetes.io/ingress.class: "traefik"
    traefik.ingress.kubernetes.io/router.middlewares: {{ .Release.Namespace }}-{{ include "webui.fullname" . }}-add-trailing-slash@kubernetescrd, {{ .Release.Namespace }}-{{ include "webui.fullname" . }}-strip-prefix@kubernetescrd
    {{- if .Values.tls.enabled }}
      ,{{ .Release.Namespace }}-{{ include "webui.fullname" . }}-https-redirect@kubernetescrd
    cert-manager.io/cluster-issuer: "letsencrypt-{{ .Values.environment }}"
    {{- end }}
spec:
  rules:
    - http:
        paths:
          - backend:
              service:
                name: {{ include "webui.fullname" . }}
                port:
                  name: "http"
            path: "/admin"
            pathType: "Prefix"
  {{- if .Values.tls.enabled }}
  tls:
    - hosts:
        - {{ .Values.tls.hostname }}
      secretName: {{.Values.tls.certSecret }}
  {{- end }}
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ include "webui.fullname" . }}-add-trailing-slash
spec:
  redirectRegex:
    regex: ^https?://(.*)/([a-z0-9_]+)$
    replacement: https://${1}/${2}/
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ include "webui.fullname" . }}-strip-prefix
spec:
  stripPrefix:
    prefixes:
      - '/admin'
{{- if .Values.tls.enabled }}
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ include "webui.fullname" . }}-https-redirect
spec:
  redirectScheme:
    scheme: https
    permanent: true
{{- end }}
